window.Gleam.initSearch([{"doc":"collatz","title":"collatz","content":"# [Collatz](https://github.com/Skenvy/Collatz): [Gleam](https://github.com/Skenvy/Collatz/tree/main/gleam) 💖⭐💖\n&lt;p align=&quot;center&quot;&gt;&lt;img alt=&quot;Banner Image, Collatz Coral&quot; src=&quot;https://raw.githubusercontent.com/wiki/Skenvy/Collatz/.meta/banners/modifications/_Gleam.png&quot; width=830 height=666/&gt;&lt;/p&gt;\n&lt;sub&gt;&lt;p align=&quot;center&quot;&gt;&lt;i&gt;\n  &lt;a href=&quot;https://github.com/Skenvy/Collatz/blob/main/.meta/banners/README.md&quot;&gt;Colourised Collatz Coral&lt;/a&gt;; derived from this\n  &lt;a href=&quot;https://twitter.com/Gelada/status/846751901756653568&quot;&gt;original by Edmund Harriss&lt;/a&gt;\n&lt;/i&gt;&lt;/p&gt;&lt;/sub&gt;\n\n---\nFunctions related to [the Collatz/Syracuse/3N+1 problem](https://en.wikipedia.org/wiki/Collatz_conjecture), implemented in [Gleam](https://gleam.run/).\n## Badges\n[![Package Version](https://img.shields.io/hexpm/v/collatz)](https://hex.pm/packages/collatz)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/collatz/)\n## Getting Started\n[To install the latest from Hex](https://hex.pm/packages?search=collatz) ([or as it appears on gleam packages](https://packages.gleam.run/?search=collatz));\n```sh\ngleam add collatz\n```\n## Usage\nProvides the basic functionality to interact with the Collatz conjecture.\nThe parameterisation uses the same `(P,a,b)` notation as Conway&#39;s generalisations.\nBesides the function and reverse function, there is also functionality to retrieve the hailstone sequence, the &quot;stopping time&quot;/&quot;total stopping time&quot;, or tree-graph. \nThe only restriction placed on parameters is that both `P` and `a` can&#39;t be `0`.\n### Usage Example\n```gleam\nimport collatz\n\npub fn main() {\n  // TODO: An example of the project in use\n}\n```\n## [&lt;lang-docs-name&gt; generated docs](https://skenvy.github.io/Collatz/gleam)\n## [HexDocs](https://hexdocs.pm/collatz)\n## Developing\n### The first time setup\n```sh\ngit clone https://github.com/Skenvy/Collatz.git &amp;&amp; cd Collatz/gleam &amp;&amp; &lt;localised-setup-command&gt;\n```\n### Iterative development\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"index.html"},{"doc":"collatz","title":"collatz","content":"# [Collatz](https://github.com/Skenvy/Collatz): [Gleam](https://github.com/Skenvy/Collatz/tree/main/gleam) 💖⭐💖\n&lt;p align=&quot;center&quot;&gt;&lt;img alt=&quot;Banner Image, Collatz Coral&quot; src=&quot;https://raw.githubusercontent.com/wiki/Skenvy/Collatz/.meta/banners/modifications/_Gleam.png&quot; width=830 height=666/&gt;&lt;/p&gt;\n&lt;sub&gt;&lt;p align=&quot;center&quot;&gt;&lt;i&gt;\n  &lt;a href=&quot;https://github.com/Skenvy/Collatz/blob/main/.meta/banners/README.md&quot;&gt;Colourised Collatz Coral&lt;/a&gt;; derived from this\n  &lt;a href=&quot;https://twitter.com/Gelada/status/846751901756653568&quot;&gt;original by Edmund Harriss&lt;/a&gt;\n&lt;/i&gt;&lt;/p&gt;&lt;/sub&gt;\n\n---\nFunctions related to [the Collatz/Syracuse/3N+1 problem](https://en.wikipedia.org/wiki/Collatz_conjecture), implemented in [Gleam](https://gleam.run/).\n## Badges\n[![Package Version](https://img.shields.io/hexpm/v/collatz)](https://hex.pm/packages/collatz)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/collatz/)\n## Getting Started\n[To install the latest from Hex](https://hex.pm/packages?search=collatz) ([or as it appears on gleam packages](https://packages.gleam.run/?search=collatz));\n```sh\ngleam add collatz\n```\n## Usage\nProvides the basic functionality to interact with the Collatz conjecture.\nThe parameterisation uses the same `(P,a,b)` notation as Conway&#39;s generalisations.\nBesides the function and reverse function, there is also functionality to retrieve the hailstone sequence, the &quot;stopping time&quot;/&quot;total stopping time&quot;, or tree-graph. \nThe only restriction placed on parameters is that both `P` and `a` can&#39;t be `0`.\n### Usage Example\n```gleam\nimport collatz\n\npub fn main() {\n  // TODO: An example of the project in use\n}\n```\n## [&lt;lang-docs-name&gt; generated docs](https://skenvy.github.io/Collatz/gleam)\n## [HexDocs](https://hexdocs.pm/collatz)\n## Developing\n### The first time setup\n```sh\ngit clone https://github.com/Skenvy/Collatz.git &amp;&amp; cd Collatz/gleam &amp;&amp; &lt;localised-setup-command&gt;\n```\n### Iterative development\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n","url":"readme.html"},{"doc":"collatz","title":"collatz","content":"# Devlog\n[Gleam](https://gleam.run/) [[gh](https://github.com/gleam-lang)|[core](https://github.com/gleam-lang/gleam)] is a _recent_ addition to the BEAM ecosystem (see [[Erlang](https://www.erlang.org/)] [[Elixir](https://elixir-lang.org/)] [[Hex](https://hex.pm/)]). Being [FLOSS](https://github.com/gleam-lang/gleam/blob/32ba73ff5401e5a976b6d250de7248b416ca9c43/LICENCE) from the [beginning](https://github.com/gleam-lang/gleam/blob/4d791cbf8e7ef93f9174103e4a547f1262cb7ace/LICENSE), maintained by nice, friendly people, and not being afraid to be immediately prescriptivist about its tooling, it should make for hopefully a gentle experience.\nRecently spiked in popularity after [its v1 release](https://gleam.run/news/gleam-version-1/), especially in the land of &quot;Streamer Driven Development&quot; [[@t3dotgg](https://www.youtube.com/watch?v=_I-CSgoCgsk)] [[@ThePrimeTimeagen](https://www.youtube.com/watch?v=9mfO821E7sE)], it&#39;s the new hype.\nThis project does not yet have an implementation from the BEAM family. I figured I&#39;d eventually think about maybe considering doing it in Elixir, which I&#39;ve heard good things about, but it&#39;d be fun to battle-test gleam&#39;s tools.\n## Setup Environment / Tools\n### &quot;Install Gleam&quot;\nFunnily enough, the [gleam home page](https://gleam.run/) doesn&#39;t link directly to downloads. The first big button is [Try Gleam](https://tour.gleam.run/) [[1](https://tour.gleam.run/table-of-contents/)], and it&#39;s good to see a fancy in-browser tour, but I am surprised that there is still yet to be a prominent &quot;download here&quot; button.\nThe top panel though links the the [**docs**](https://gleam.run/documentation/), and the third link in here is where we see [Installing Gleam](https://gleam.run/getting-started/installing/). There are three parts to this. We&#39;ll be setting it up in Ubuntu WSL and Windows.\n### Install &quot;Gleam&quot;\nFirst, it will have us go to [the releases page](https://github.com/gleam-lang/gleam/releases), unless you want to use one of the package managers it&#39;s available in. But there is no `apt` install of it, so to the release page we go. It&#39;s not written anywhere there I can see, but we can put together;\n```sh\nVERSION=1.0.0 curl -s -L https://github.com/gleam-lang/gleam/releases/download/v$VERSION/gleam-v$VERSION-x86_64-unknown-linux-musl.tar.gz | tar xvz -C /tmp &amp;&amp; mv /tmp/gleam ~/.local/bin/gleam\n```\nAnd we can install the windows side manually. I&#39;m _surprised_ there isn&#39;t an installer yet, at least, because there&#39;re smaller products that have installers. But that&#39;s not an issue. And it&#39;s probably expected the users will know how to set their paths / manage multiple installs.\n### Install Erlang\nThe gleam site recommends the [&quot;Erlang solutions website&quot;](https://www.erlang-solutions.com/resources/download.html), but surely [Download Erlang/OTP](https://www.erlang.org/downloads) is good as well? We can `sudo apt install erlang` and accept the half a Gb install, and download and run the windows installer. Windows side installed fine, `14.2.3`, but the WSL side required a `sudo apt --fix-broken install` followed by another `sudo apt install erlang`, and now it&#39;s on `10.6.4`.\nIt turns out later, that for rebar3, they &quot;support the 3 latest major releases of erlang&quot;, and the number that comes back for `erl -version` is not the version of erlang, which can elsewise be obtained by running `erl -eval &#39;erlang:display(erlang:system_info(otp_release)), halt().&#39;  -noshell` which shows us that on Windows we have version 26, and on WSL version 22. To update our WSL version we can;\n```sh\ncurl -L https://binaries2.erlang-solutions.com/ubuntu/pool/contrib/e/esl-erlang/esl-erlang_25.0-1~ubuntu~focal_amd64.deb -o /tmp/esl-erlang_25.0-1.deb &amp;&amp; sudo dpkg -i /tmp/esl-erlang_25.0-1.deb &amp;&amp; rm /tmp/esl-erlang_25.0-1.deb\n# But it needs sudo dpkg --auto-deconfigure -i /tmp/esl-erlang_25.0-1.deb, which then asks for;\nsudo apt --fix-broken install &amp;&amp; sudo apt autoremove -y\n# And then it also needs manual dependencies\nsudo apt install libncurses5 libsctp1\n# Which once again wants a\nsudo apt --fix-broken install\n# Which asks to confirm to install libncurses5 libsctp1 libtinfo5, and NOW we can install the deb pkg.\n# At least `rebar3 local install` works without any further complaints after fighting the erlang installation.\n```\n### Install [Rebar](https://rebar3.org/)\nThe gleam page simply says to follow [the rebar page](https://rebar3.org/docs/getting-started/). (Also see [gh:rebar3](https://github.com/erlang/rebar3)).\n```sh\ncurl -L https://s3.amazonaws.com/rebar3/rebar3 -o ~/.local/bin/rebar3 &amp;&amp; chmod +x ~/.local/bin/rebar3 &amp;&amp; rebar3 local install\n```\nYet, although the rebar3 page funnily enough makes a point of driving home that it should just work with any installed erlang, trying to run it on the version of erlang installed by apt on ubuntu 20 yields an;\n```\nescript: exception error: undefined function rebar3:main/1\n  in function  escript:run/2 (escript.erl, line 758)\n  in call from escript:start/1 (escript.erl, line 277)\n  in call from init:start_em/1\n  in call from init:do_boot/3\n=ERROR REPORT==== 19-Mar-2024::23:33:00.202362 ===\nbeam/beam_load.c(1876): Error loading module rebar3:\n  This BEAM file was compiled for a later version of the run-time system than 22.\n  To fix this, please recompile this module with an 22 compiler.\n  (Use of opcode 172; this emulator supports only up to 168.)\n```\nAnd on windows, adding the `rebar3.cmd` file adjacent to the `rebar3` with the contents it recommends yields a `===&gt; Sorry, this feature is not yet available on Windows.`. So I guess we need to just use the file and the cmd script on Windows, and try updating Erlang in Ubuntu. The latest version that [Erlang Solutions](https://www.erlang-solutions.com/downloads/) provides for Ubuntu is 25. And after fighting the upgrade to Erlang version 25, `rebar3 local install` works as expected.\n### Install Editor Plugin\nA quick search on the vsc marketplace yields an official [VS Code Plugin](https://github.com/gleam-lang/vscode-gleam).\n### &quot;Writing Gleam&quot;\n[Writing Gleam](https://gleam.run/writing-gleam/) is an example of how to create a new gleam project; `gleam new &lt;project-name&gt;`. We&#39;ll run `gleam new collatz`, and mesh together what it produces with `here`.\n### Packaging for Hex\nWe&#39;ll need to take a look at [`gleam.toml` config](https://gleam.run/writing-gleam/gleam-toml/), [gleam&#39;s cli](https://gleam.run/writing-gleam/command-line-reference/), [Hex Sign up](https://hex.pm/signup), [Hex Publishing a package](https://hex.pm/docs/publish), and [HexDocs](https://hexdocs.pm/).\nSigning up at [Hex Sign up](https://hex.pm/signup) is very simple. After verifying our email, it&#39;s a good idea to setup [2fa](https://hex.pm/dashboard/security).\nWe can publish packages with `gleam publish`, which at the moment requires `HEXPM_USER` (Hex username) and `HEXPM_PASS` (Hex password).\n","url":"devlog.html"},{"doc":"collatz","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\ncollatz.main\ncollatz main","url":"collatz.html#main"},{"doc":"collatz","title":"collatz","content":"","url":"collatz.html"}]);